#!/bin/bash

. ./scripts/env.sh

cd $DEPS

echo "Downloading $ZK from $ZK_URL"

curl -C - --fail --output $ZK_FILE $ZK_URL || wget --continue $ZK_URL -O $ZK_FILE

if [ $? != 0 ] ; then
    echo "Unable to download zookeeper library"
    exit 1
fi

rm -rf $ZK_DEPS

tar zxf  $ZK_FILE $ZK/src/c

mv $ZK $ZK_DEPS

cd $ZK_DEPS

echo "Applying patches"
for PATCH in $PATCHES; do
    echo "Patching: $PATCH"
    patch -p0 < $PATCH
    if [ $? != 0 ] ; then
            echo "Unable to patch the ZooKeeper source"
            exit 1
    fi
done
